#pragma once

#include <RobotAPI/components/ArViz/Client/Client.h>
#include <RobotAPI/components/ArViz/Client/ScopedClient.h>

#include "datatypes/CommonPlace.h"

namespace armarx::priorknowledge::util::common_place
{

    class Visu
    {
    public:
        struct CommonPlaceData
        {
            Eigen::Matrix4f globalPose;
            std::string objectId;
        };

        Visu(viz::Client& arviz) : arviz(arviz)

        {
        }

        ~Visu() = default;

        viz::Layer commonPlaceToLayer(const std::string& layerName,
                                      const std::map<std::string, CommonPlaceData>& data) const;


    public:
        struct Settings
        {

        } settings;

    protected:
        viz::Client& arviz;
    };
} // namespace armarx::priorknowledge::util::common_place
