#include "ExrConverter.h"

// ArmarX
#include <opencv2/imgcodecs.hpp>
#include <opencv2/imgproc.hpp>
#include <opencv2/opencv.hpp>

#include <RobotAPI/libraries/aron/converter/opencv/OpenCVConverter.h>

namespace armarx::armem::server::ltm::processor::converter::data::image
{
    ExrConverter::ConversionResult
    ExrConverter::_convert(const aron::data::NDArrayPtr& data)
    {
        ARMARX_CHECK_NOT_NULL(data);

        auto img = aron::data::converter::AronOpenCVConverter::ConvertToMat(data);
        std::vector<unsigned char> buffer;

        auto shape = data->getShape(); // we know from the extraction that the shape has 3 elements
        ARMARX_CHECK_EQUAL(shape.size(), 3);
        ARMARX_CHECK_EQUAL(shape[2], 4);

        cv::imencode(".exr", img, buffer);
        return {buffer, ""};
    }

    aron::data::NDArrayPtr
    ExrConverter::_convert(const ConversionResult& data, const armarx::aron::Path& p)
    {
        cv::Mat img = cv::imdecode(data.data, cv::IMREAD_ANYDEPTH);
        return aron::data::converter::AronOpenCVConverter::ConvertFromMat(img, p);
    }
} // namespace armarx::armem::server::ltm::processor::converter::data::image
