#pragma once

// STD/STL
#include <memory>

// Simox
#include <SimoxUtility/json.h>

// ArmarX
#include <RobotAPI/libraries/aron/core/data/variant/complex/NDArray.h>
#include <RobotAPI/libraries/aron/core/data/variant/container/Dict.h>

namespace armarx::armem::server::ltm::processor
{
    class Extractor
    {
    public:
        struct ExtractionResult
        {
            aron::data::DictPtr dataWithoutExtraction;
            std::map<std::string, aron::data::VariantPtr> extraction;
        };

        Extractor(const aron::type::Descriptor t, const std::string& id) :
            extractsType(t), identifier(id){};
        virtual ~Extractor() = default;

        virtual ExtractionResult extract(aron::data::DictPtr& data) = 0;
        virtual aron::data::DictPtr merge(ExtractionResult& encoding) = 0;

        virtual void configure(const nlohmann::json& json);

        const aron::type::Descriptor extractsType;
        const std::string identifier;
    };
} // namespace armarx::armem::server::ltm::processor
