#pragma once

// STD/STL
#include <memory>

// Simox
#include <SimoxUtility/json.h>

// ArmarX
#include <RobotAPI/libraries/armem/core/MemoryID.h>
#include <RobotAPI/libraries/armem/core/wm/memory_definitions.h>

namespace armarx::armem::server::ltm::processor
{
    class MemoryFilter
    {
    public:
        MemoryFilter() = default;
        virtual ~MemoryFilter() = default;

        virtual bool accept(const armem::wm::Memory& e) = 0;
        virtual void configure(const nlohmann::json& json);
    };

    class SnapshotFilter
    {
    public:
        SnapshotFilter() = default;
        virtual ~SnapshotFilter() = default;

        virtual bool accept(const armem::wm::EntitySnapshot& e) = 0;
        virtual void configure(const nlohmann::json& json);
    };
} // namespace armarx::armem::server::ltm::processor
